WinDirStat

WinDirStat - Directory Statistics

Copyright (c) 2003-2005 Bernhard Seifert. Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.2 or any later version published by the Free Software Foundation; with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts. A copy of the license is included in the section entitled "GNU Free Documentation License".

Shows where all your disk space has gone, and helps you clean it up.

You know the problem: The hard disk is almost full, and you don't know, where the big files actually are lying, which occupy all the space. They may well be hidden in sub-sub-directories. To find out this by means of the Windows Explorer, is tiring: you would have to expand and collapse directories over and over or view the "Properties" of the directories, which always count just the size of a single subtree. It's hard to form a mental image of the hard disk usage in this way. This is where WinDirStat helps.

On start up WinDirStat opens the Select Drives Dialog. Press the OK button.

Then WinDirStat reads in the whole directory tree once (this can last some minutes depending on the hard disk size) and then presents it in three useful views:

WinDirStat
Directory List Extension List
Treemap

The views are coupled with each other.

You can clean up the hard disks with several Cleanups.

The views and the User Defined Cleanups can be configured according to your personal needs.

Sorting

Legend

Frequently Asked Questions

Limits

Deinstallation

GNU Free Documentation License


What is a Directory Tree?

On most computer operating systems, so on Microsoft Windows, the data on the hard disk are organized hierarchically.

On the one hand there are the files which have a certain size and contain the effective data. Each file has a name. Under Microsoft Windows the "filename extension" informs about the type of the file. The extension ".exe", for instance, indicates that it's a program file. The extension ".doc" indicates a WinWord document, ".jpg" is a photo, and so on. But ridiculously the Microsoft Windows Explorer hides these filename extensions by default. You can change this behaviour in the options menu of the Windows Explorer.

On the other hand there are directories. The Windows Explorer and WinDirStat, too, symbolize directories as yellow folders. Directories also have a name, but normally without a filename extension. Directories only serve to contain files and other directories ("sub-directories"). Due to the fact that directories can contain subdirectories, and those again can contain subdirectories, the result is a hierarchical structure on the disk.

Instead of "hierarchical structure" we simply say tree structure. Since a tree is built hierarchical as well: The trunk branches out into branches, the branches into sub-branches, twigs and finally into the leaves. In a file system the so called root directory is the trunk, the directories are the branches and the files are the leaves.

That's why we call the file system of a computer simply a "directory tree".

Unlike most real trees, on a disk the trunk and the branches already have leaves. And, unlike most real trees, too: the files are the voluminous entities (the size of which is measured by megabytes or gigabytes), whereas the actual directories are neglectibly small. By the way, we imagine abstract trees as turned round: the root at the top, the leaves at the bottom.

If you saw a branch off a tree and stick it into the earth, then it becomes itself a little tree (well, at least it looks like one): Every branch is, together with its sub-branches and leaves, itself a tree, a subtree.

The family tree metaphor is often used as well: The subdirectories and files of a directory are called its children. And a directory containing a subdirectory or file is called their parent. The root directory is earliest ancestor of all items in the directory tree.

A path like "C:\documents\letters\draft\loveletter.doc" indicates that on the hard disk C:, in the root directory "C:\" there is a directory "documents", under it the subdirectory "letters", under it a subdirectory "draft" and in there a file "loveletter.doc". So the path is a precise representation of the way from the root to the leaf.


Directory List

The directory list resembles the tree view of the Windows Explorer, with the difference that it shows directories and files sorted by size descending. At the top you see the directories and files, which use up most space. When you expand a directory, its subdirectories are shown again sorted by size, and so on.

Columns

  • Name. This column shows the names of the files and directories and their tree structure.
  • Size. For files, this is the size of the file, in bytes. For directories, this is the size of the subtree, that is the sum of the sizes of all subdirectories and files.
  • Subtree Percentage. This column shows, how the size of a subtree is composed of the sizes of the sub-items. This information is comparable only within one level and is always related to the expanded parent item.
    [During the scanning, this column shows either a pacman or the number of read jobs to do for the subtree.]
  • Percentage. The same information as in "Subtree Percentage", in percent.
    [During the scanning, this column can optionally show the time spent for the subtree so far.]
  • Files. Number of files in the subtree.
  • Subdirs. Number of sub-directories in the subtree.
  • Items. Number of items in the subtree. Sum of "Files" and "Subdirs".
  • Last Change. Date of the last modification in the subtree.
  • Attributes. File/folder attributes. R = read-only, H = hidden, S = system, A = archive, C = compressed, E = encrypted.

Operation

In the column "Name" you can expand and collapse the directories by a mouse click on the little boxes with + and -, as in the Windows Explorer. A click on a name selects an item. After that you can navigate in the tree with the arrow keys.

The treemap always highlights the selected item with a frame.

If you select a file, the extension list automatically shows its type.

The sorting can be set with a mouse click on a column header.


Extension List

The extension list contains all types (filename extensions) occurring in the directory tree. For every file type the column "Bytes" shows the sum of the file sizes. By default, the extension list is sorted descending by this column. So at the top are those files types, which all in all take up most space on the hard disk.

12 colors are assigned to the 12 file types, which take up most space. The rest is grey. The treemap shows the files in these colors.

Columns

  • Extension. Icon and filename extension.
  • Color. The color, which is used by the treemap to display the files of this type.
  • Description. Description of the file type. Corresponds to the description shown by the Windows Explorer.
  • Bytes. Total volume of the file type in the directory tree. Sum of the sizes of all files of this type.
  • % Bytes. The same information as proportion related to the overall tree size.
  • Files. Number of files of this type in the directory tree.

Operation

Click on an extension: The treemap highlights all files of this type.


Treemap

The treemap shows the whole contents of the directory tree straight away.

It represents each file as a colored rectangle, the area of which is proportional to the file's size.

The rectangles are arranged in such a way, that directories again make up rectangles, which contain all their files and subdirectories. So their area is proportional to the size of the subtrees.

The color of a rectangle indicates the type of the file, as shown in the extension list.

The cushion shading additionally brings out the directory structure.

Operation

You effortlessly see the big rectangles, that is the big files, even if they are hidden deeply in subdirectories in the directory tree. Click on them: the directory list opens the path to the file, and you can read its location and attributes, and - if you like - apply a cleanup action on it, e.g. delete the file.

Navigate in the directory list: the respective selection is highlighted with a colored frame. In this way gain an impression of the proportions: How big, for example, is C:\windows compared with C:\program files?

The context menu options "Select Parent" and "Re-select Child" are also useful for the navigation.

Zoom. The option "Zoom in" enlarges the treemap, so that a subtree is displayed full size. As it were you make a step towards the selected item. The directory list show the root of this subtree with a blue frame. By "Zoom out" you step back, and the parent element is shown again.


Coupling of the Views

The really strong point of WinDirStat is, that the three views, Directory List, Extension List and Treemap, are coupled with each other.

Directory List -> Treemap

When you select an item (directory or file) in the directory list, the treemap also shows this item by highlighting it with a colored frame. In particular you can see the size of directories.

Treemap -> Directory List

When you click into the treemap, the mouse always hits a file (a colored rectangle). After that the directory list expands (if necessary) the appropriate nodes and selects this file. So you can, e.g. by clicking on a big rectangle, see path and attributes of the corresponding big file in the directory list.

So, because of this mutual coupling, the selections in the directory list and in the treemap are always the same.

Directory List + Treemap -> Extension List

When you select a file in the directory list (or in the treemap), the extension list shows the file type (the extension). The extension is selected and scrolled into view. So you can see the description and the statistics for this file type.

Extension List -> Treemap

When you select a file type in the extension list, the treemap highlights all files of this type.


Select Drives Dialog

Here you can decide which drives to include in the statistics.

You can select one or more drives from the list or choose a directory.

The list shows all present drives (hard disks, inserted floppy disks or CDs, and network drives).

Columns

  • Name. Name and drive letter of the drive.
  • Total. Capacity of the drive.
  • Free. Free space on the drive.
  • Used/Total Percentage of used space, related to the capacity.
  • Used/Total The same information in percent.

Operation

The dialog box has three "radio buttons".

  • All local drives. This is the default. Scans all local drives, that is all drives, which are not network drives. Drives created with SUBST are also excluded (NT and higher only).
  • Individual drives. Here you can explicitly select a set of drives.
  • A folder. Here you can select a folder or an UNC path.
Click on OK to begin the scan.

The selection is persistent, i.e. when you open the dialog the next time, the default setting will be that which you made the last time.


Clenaups

Cleanups

Serveral clean up actions can be applied to a selected item. The cleanups are accessible through the main menu, the tool bar and through keyboard shortcuts.

Refresh Selected

Possibly an item has been deleted or modified outside of WinDirStat. "Refresh" makes WinDirStat re-read the item, so that the display accords with the actual conditions on the hard disk again.

Copy Path

Copies the path of the selected item into the clipboard.

Open

Opens the selected file. Note that in case of an executable file (.exe), this means that the program is started.

Explorer here

Launches the Windows Explorer so that it shows the selected item.

Command Prompt here

Launches the DOS prompt in the selected directory.

Delete (to Recycle Bin)

Moves the selected item into the recycle bin. Then the item and the recycle bin directories are refreshed.

Delete (no way to undelete)

Deletes the selected item irreversibly. Then the item is refreshed. Please delete only files and directories, when you know that neither you nor the system needs it any more!

Properties

Opens the 'Properties' dialog for the selected file.

Send Mail to Owner

Generates a textual report about the selected directory, which can be sent a via e-mail to its owner. This is intended for network drives, which are used by several people. The report accurately contains the lines displayed in the directory list underneath the selected item, in the same "expansion state" and in the same sort order.

User Defined Cleanups

In addition to these built-in clean ups you can freely define your own cleanups.


User Defined Cleanups

This feature is for experts.

You can define up to 10 custom cleanup actions. The cleanups are specified by command lines.

Select an entry in the list an set it to "enabled". Choose a title, the title appears in the menus.

Compose a command line. Use the "MSDOS prompt" (Windows 9x, command.com) or the "Command prompt" (NT, cmd.exe) to get help about the available commands and to test the command line.

Examples

  • dir /b > dir.txt
    List the filenames to the text file dir.txt.
  • del *.bak
    Delete all *.bak files in the current directory.
  • del /s *.bak *.tmp
    Recursively delete all *.bak and *.tmp files.
  • windirstat.exe "%p"
    Call up a second instance of WinDirStat with the path of the selected directory (a PATH to windirstat.exe must be set).

Examples (NT and higher)

  • echo %n & pause
    Display the name of the current directory.
  • cd & pause
    Display the current path and wait for a key stroke.
  • cd .. && myzip "%n"
    Compress the selected directory (with the hypothetic tool myzip).

The meaning of the placeholders %p, %n, %sp, %sn is shown in the dialog. Don't forget to enclose them in quotation marks, if necessary.

Assembly of the command line

Suppose you enter the command line

xyz
. WinDirStat then trys to start the following process:
%COMSPEC% /c xyz

More Options

Specify, for which item types the cleanup works. Be careful with UNC paths: a command prompt cannot chdir to UNC paths!

Specify, whether the cleanup shall be applied recursively on all subdirectories (depth first).

The other options should be clear.


Configuration

General

Cross file system boundaries (only NT and higher). Under NTFS volumes can be mounted in directories. By default WinDirStat stops reading at these mount points, i.e. it shows only the usage of one file system. Here you can change this behavior. (No mount points are recognized on UNC drives.)

Follow Junction Points (except Volume Mount Points) (only NT and higher). Under NTFS target folders can be grafted onto another folder by using junction points. (You need a third-party tool, e.g. awxlink, downloadable from http://www.arniworld.de/, to create junction points.) By default WinDirStat stops reading at these junction points. Here you can change this behavior.

List Style. These options, grid and stripes, apply to all lists in WinDirStat.

Language. In addition to the built-in language English, this combo box offers those languages, for which a correspondig wdsrxxxx.dll exists. The setting takes effect next time when WinDirStat is started.

Directory List

Two options which control what the columns 'Subtree Percentage' and 'Percentage' display during the scan. Colors for the subtree percentage presentation.

Treemap

Squarification style, parameters for the cushion shading, grid lines, color of the selection rectangle.

Cleanups

Here you can configure the User Defined Cleanups.

Report

Administrators can customize the e-mail report feature here.


Sorting

All lists in WinDirStat can be sorted at will. The current sorting is indicated by the symbols < and > in the column headings. < means ascending sort, > means descending sort.

You can set the desired sorting by a mouse click on a column heading.

Actually two columns are drawn on the sorting. First that one, on which you clicked last, and second - if the elements are equal regarding this column - that, which sorted before.

Note that the sorting of the directory list of course respects the tree structure: sorting occurs only within one level.

Annotation

The column widths and column order can be adjusted via drag 'n drop. The widths and column order are persistent; that is, at program start they are automatically restored as you have set them last.


Legend

<Files>

Generally, each directory in the directory list has a pseudo subdirectory <Files>. There, all ordinary files of the directory are put together. That is, all files, which are immediate children of the directory, not those of subdirectories. This has the advantage, that the directory list is cleaner and that the statistics is sounder. Because with this item you can see how much space is used all in all by the files of the directory (not of subdirectories).

The <Files> item is omitted, if there is only one file in the directory, or if it has no subdirectories.

<Free Space>

If you have activated "Show Free Space" in the Options menu, each drive has an <Free Space> item. The size of this item tallies with the amount of free space available on the drive. In the treemap this item has a dark grey color. Through the <Free Space> item you get an impression of the ratio between the totally used disk space and the free disk space. This information corresponds with the value shown in the Windows Explorer properties dialog for the drive.

<Unknown>

If you have activated "Show Unknown" in the Options menu, each drive has an <Unknown> item. The matter is as follows. On the one hand, WinDirStat knows the total capacity of the drive and the free disk space. (These values tally with the number shown by the Windows Explorer properties dialog for the drive.) On the other hand WinDirStat has determined the sizes of all files and added them up. Well, <Unknown> is the difference: Total capacity minus free space minus determined sum. This rest can be greater than zero by serveral reasons. For instance there can be directories (e.g. "System Volume Information") with read-access denied. Their size cannot be included in the sum calculated by WinDirStat. In the treemap, the <Unknown> item is colored vivid yellow.

< (in column headings)

indicates that the list is sorted by this column in ascending order.

> (in column headings)

indicates that the list is sorted by this column in descending order.


Frequently Asked Questions

Does the treemap relate to the allocation of hard disk sectors?

No. The treemap view has nothing to do with hard disk sectors. Generally big files are scattered on the hard disk. The treemap on the other hand shows each file as one rectangle.

Does WinDirStat start threads for the read jobs?

No. WinDirStat is - apart from the about box, which runs in an own thread, and apart from the drive querying in the drive selection dialog - single-threaded. All work is done in OnIdle().

What does the item <Files> mean?

See Legend.

What does the > symbol in front of the column captions mean?

The > and < symbols in the column headers indicate the current sorting.

On my XP WinDirStat shows more than a GB <Unknown>, what's wrong?

Nothing. XP quite often creates rather big 'System restore points' under C:\System Volume Information, but denies access to it.

What is the file wdsr0407.dll for?

This file contains the German translation of WinDirStat. 0407 is the language identifier for "German - Germany". If this file is absent, then WinDirStat is available in the (built-in) language English only.

The size information in KB and MB seems to be a bit too small.

WinDirStat sticks to the computing convention, that "kilo" doesn't stand for
            1000 but for 1024. So we have:
1 KB = 1024 Bytes
1 MB = 1024 KB = 1,048,576 Bytes
1 GB = 1024 MB = 1,048,576 KB = 1,073,741,824 Bytes.


Limits

Time spent on scanning | 2^32 ms (= 49 days)
Number of direct subitems of a directory | 2^31 (= 2,147,483,648)
File size, tree size | 2^63 (= 8,388,608 TB)
Total number of items | 2^63
Number of concurrent read jobs | 2^63


Deinstallation

  • Remove the directory C:\program files\windirstat
  • Remove the shortcuts for WinDirStat
  • For experts: Remove HKCU\Software\seifert\windirstat.


GNU Free Documentation License

Version 1.2, November 2002

Copyright (C) 2000,2001,2002  Free Software Foundation, Inc.
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.

0. PREAMBLE

The purpose of this License is to make a manual, textbook, or other functional and useful document "free" in the sense of freedom: to assure everyone the effective freedom to copy and redistribute it, with or without modifying it, either commercially or noncommercially. Secondarily, this License preserves for the author and publisher a way to get credit for their work, while not being considered responsible for modifications made by others.

This License is a kind of "copyleft", which means that derivative works of the document must themselves be free in the same sense. It complements the GNU General Public License, which is a copyleft license designed for free software.

We have designed this License in order to use it for manuals for free software, because free software needs free documentation: a free program should come with manuals providing the same freedoms that the software does. But this License is not limited to software manuals; it can be used for any textual work, regardless of subject matter or whether it is published as a printed book. We recommend this License principally for works whose purpose is instruction or reference.

1. APPLICABILITY AND DEFINITIONS

This License applies to any manual or other work, in any medium, that contains a notice placed by the copyright holder saying it can be distributed under the terms of this License. Such a notice grants a world-wide, royalty-free license, unlimited in duration, to use that work under the conditions stated herein. The "Document", below, refers to any such manual or work. Any member of the public is a licensee, and is addressed as "you". You accept the license if you copy, modify or distribute the work in a way requiring permission under copyright law.

A "Modified Version" of the Document means any work containing the Document or a portion of it, either copied verbatim, or with modifications and/or translated into another language.

A "Secondary Section" is a named appendix or a front-matter section of the Document that deals exclusively with the relationship of the publishers or authors of the Document to the Document's overall subject (or to related matters) and contains nothing that could fall directly within that overall subject. (Thus, if the Document is in part a textbook of mathematics, a Secondary Section may not explain any mathematics.) The relationship could be a matter of historical connection with the subject or with related matters, or of legal, commercial, philosophical, ethical or political position regarding them.

The "Invariant Sections" are certain Secondary Sections whose titles are designated, as being those of Invariant Sections, in the notice that says that the Document is released under this License. If a section does not fit the above definition of Secondary then it is not allowed to be designated as Invariant. The Document may contain zero Invariant Sections. If the Document does not identify any Invariant Sections then there are none.

The "Cover Texts" are certain short passages of text that are listed, as Front-Cover Texts or Back-Cover Texts, in the notice that says that the Document is released under this License. A Front-Cover Text may be at most 5 words, and a Back-Cover Text may be at most 25 words.

A "Transparent" copy of the Document means a machine-readable copy, represented in a format whose specification is available to the general public, that is suitable for revising the document straightforwardly with generic text editors or (for images composed of pixels) generic paint programs or (for drawings) some widely available drawing editor, and that is suitable for input to text formatters or for automatic translation to a variety of formats suitable for input to text formatters. A copy made in an otherwise Transparent file format whose markup, or absence of markup, has been arranged to thwart or discourage subsequent modification by readers is not Transparent. An image format is not Transparent if used for any substantial amount of text. A copy that is not "Transparent" is called "Opaque".

Examples of suitable formats for Transparent copies include plain ASCII without markup, Texinfo input format, LaTeX input format, SGML or XML using a publicly available DTD, and standard-conforming simple HTML, PostScript or PDF designed for human modification. Examples of transparent image formats include PNG, XCF and JPG. Opaque formats include proprietary formats that can be read and edited only by proprietary word processors, SGML or XML for which the DTD and/or processing tools are not generally available, and the machine-generated HTML, PostScript or PDF produced by some word processors for output purposes only.

The "Title Page" means, for a printed book, the title page itself, plus such following pages as are needed to hold, legibly, the material this License requires to appear in the title page. For works in formats which do not have any title page as such, "Title Page" means the text near the most prominent appearance of the work's title, preceding the beginning of the body of the text.

A section "Entitled XYZ" means a named subunit of the Document whose title either is precisely XYZ or contains XYZ in parentheses following text that translates XYZ in another language. (Here XYZ stands for a specific section name mentioned below, such as "Acknowledgements", "Dedications", "Endorsements", or "History".) To "Preserve the Title" of such a section when you modify the Document means that it remains a section "Entitled XYZ" according to this definition.

The Document may include Warranty Disclaimers next to the notice which states that this License applies to the Document. These Warranty Disclaimers are considered to be included by reference in this License, but only as regards disclaiming warranties: any other implication that these Warranty Disclaimers may have is void and has no effect on the meaning of this License.

2. VERBATIM COPYING

You may copy and distribute the Document in any medium, either commercially or noncommercially, provided that this License, the copyright notices, and the license notice saying this License applies to the Document are reproduced in all copies, and that you add no other conditions whatsoever to those of this License. You may not use technical measures to obstruct or control the reading or further copying of the copies you make or distribute. However, you may accept compensation in exchange for copies. If you distribute a large enough number of copies you must also follow the conditions in section 3.

You may also lend copies, under the same conditions stated above, and you may publicly display copies.

3. COPYING IN QUANTITY

If you publish printed copies (or copies in media that commonly have printed covers) of the Document, numbering more than 100, and the Document's license notice requires Cover Texts, you must enclose the copies in covers that carry, clearly and legibly, all these Cover Texts: Front-Cover Texts on the front cover, and Back-Cover Texts on the back cover. Both covers must also clearly and legibly identify you as the publisher of these copies. The front cover must present the full title with all words of the title equally prominent and visible. You may add other material on the covers in addition. Copying with changes limited to the covers, as long as they preserve the title of the Document and satisfy these conditions, can be treated as verbatim copying in other respects.

If the required texts for either cover are too voluminous to fit legibly, you should put the first ones listed (as many as fit reasonably) on the actual cover, and continue the rest onto adjacent pages.

If you publish or distribute Opaque copies of the Document numbering more than 100, you must either include a machine-readable Transparent copy along with each Opaque copy, or state in or with each Opaque copy a computer-network location from which the general network-using public has access to download using public-standard network protocols a complete Transparent copy of the Document, free of added material. If you use the latter option, you must take reasonably prudent steps, when you begin distribution of Opaque copies in quantity, to ensure that this Transparent copy will remain thus accessible at the stated location until at least one year after the last time you distribute an Opaque copy (directly or through your agents or retailers) of that edition to the public.

It is requested, but not required, that you contact the authors of the Document well before redistributing any large number of copies, to give them a chance to provide you with an updated version of the Document.

4. MODIFICATIONS

You may copy and distribute a Modified Version of the Document under the conditions of sections 2 and 3 above, provided that you release the Modified Version under precisely this License, with the Modified Version filling the role of the Document, thus licensing distribution and modification of the Modified Version to whoever possesses a copy of it. In addition, you must do these things in the Modified Version:

  • A. Use in the Title Page (and on the covers, if any) a title distinct from that of the Document, and from those of previous versions (which should, if there were any, be listed in the History section of the Document). You may use the same title as a previous version if the original publisher of that version gives permission.
  • B. List on the Title Page, as authors, one or more persons or entities responsible for authorship of the modifications in the Modified Version, together with at least five of the principal authors of the Document (all of its principal authors, if it has fewer than five), unless they release you from this requirement.
  • C. State on the Title page the name of the publisher of the Modified Version, as the publisher.
  • D. Preserve all the copyright notices of the Document.
  • E. Add an appropriate copyright notice for your modifications adjacent to the other copyright notices.
  • F. Include, immediately after the copyright notices, a license notice giving the public permission to use the Modified Version under the terms of this License, in the form shown in the Addendum below.
  • G. Preserve in that license notice the full lists of Invariant Sections and required Cover Texts given in the Document's license notice.
  • H. Include an unaltered copy of this License.
  • I. Preserve the section Entitled "History", Preserve its Title, and add to it an item stating at least the title, year, new authors, and publisher of the Modified Version as given on the Title Page. If there is no section Entitled "History" in the Document, create one stating the title, year, authors, and publisher of the Document as given on its Title Page, then add an item describing the Modified Version as stated in the previous sentence.
  • J. Preserve the network location, if any, given in the Document for public access to a Transparent copy of the Document, and likewise the network locations given in the Document for previous versions it was based on. These may be placed in the "History" section. You may omit a network location for a work that was published at least four years before the Document itself, or if the original publisher of the version it refers to gives permission.
  • K. For any section Entitled "Acknowledgements" or "Dedications", Preserve the Title of the section, and preserve in the section all the substance and tone of each of the contributor acknowledgements and/or dedications given therein.
  • L. Preserve all the Invariant Sections of the Document, unaltered in their text and in their titles. Section numbers or the equivalent are not considered part of the section titles.
  • M. Delete any section Entitled "Endorsements". Such a section may not be included in the Modified Version.
  • N. Do not retitle any existing section to be Entitled "Endorsements" or to conflict in title with any Invariant Section.
  • O. Preserve any Warranty Disclaimers.

If the Modified Version includes new front-matter sections or appendices that qualify as Secondary Sections and contain no material copied from the Document, you may at your option designate some or all of these sections as invariant. To do this, add their titles to the list of Invariant Sections in the Modified Version's license notice. These titles must be distinct from any other section titles.

You may add a section Entitled "Endorsements", provided it contains nothing but endorsements of your Modified Version by various parties--for example, statements of peer review or that the text has been approved by an organization as the authoritative definition of a standard.

You may add a passage of up to five words as a Front-Cover Text, and a passage of up to 25 words as a Back-Cover Text, to the end of the list of Cover Texts in the Modified Version. Only one passage of Front-Cover Text and one of Back-Cover Text may be added by (or through arrangements made by) any one entity. If the Document already includes a cover text for the same cover, previously added by you or by arrangement made by the same entity you are acting on behalf of, you may not add another; but you may replace the old one, on explicit permission from the previous publisher that added the old one.

The author(s) and publisher(s) of the Document do not by this License give permission to use their names for publicity for or to assert or imply endorsement of any Modified Version.

5. COMBINING DOCUMENTS

You may combine the Document with other documents released under this License, under the terms defined in section 4 above for modified versions, provided that you include in the combination all of the Invariant Sections of all of the original documents, unmodified, and list them all as Invariant Sections of your combined work in its license notice, and that you preserve all their Warranty Disclaimers.

The combined work need only contain one copy of this License, and multiple identical Invariant Sections may be replaced with a single copy. If there are multiple Invariant Sections with the same name but different contents, make the title of each such section unique by adding at the end of it, in parentheses, the name of the original author or publisher of that section if known, or else a unique number. Make the same adjustment to the section titles in the list of Invariant Sections in the license notice of the combined work.

In the combination, you must combine any sections Entitled "History" in the various original documents, forming one section Entitled "History"; likewise combine any sections Entitled "Acknowledgements", and any sections Entitled "Dedications". You must delete all sections Entitled "Endorsements."

6. COLLECTIONS OF DOCUMENTS

You may make a collection consisting of the Document and other documents released under this License, and replace the individual copies of this License in the various documents with a single copy that is included in the collection, provided that you follow the rules of this License for verbatim copying of each of the documents in all other respects.

You may extract a single document from such a collection, and distribute it individually under this License, provided you insert a copy of this License into the extracted document, and follow this License in all other respects regarding verbatim copying of that document.

7. AGGREGATION WITH INDEPENDENT WORKS

A compilation of the Document or its derivatives with other separate and independent documents or works, in or on a volume of a storage or distribution medium, is called an "aggregate" if the copyright resulting from the compilation is not used to limit the legal rights of the compilation's users beyond what the individual works permit. When the Document is included in an aggregate, this License does not apply to the other works in the aggregate which are not themselves derivative works of the Document.

If the Cover Text requirement of section 3 is applicable to these copies of the Document, then if the Document is less than one half of the entire aggregate, the Document's Cover Texts may be placed on covers that bracket the Document within the aggregate, or the electronic equivalent of covers if the Document is in electronic form. Otherwise they must appear on printed covers that bracket the whole aggregate.

8. TRANSLATION

Translation is considered a kind of modification, so you may distribute translations of the Document under the terms of section 4. Replacing Invariant Sections with translations requires special permission from their copyright holders, but you may include translations of some or all Invariant Sections in addition to the original versions of these Invariant Sections. You may include a translation of this License, and all the license notices in the Document, and any Warranty Disclaimers, provided that you also include the original English version of this License and the original versions of those notices and disclaimers. In case of a disagreement between the translation and the original version of this License or a notice or disclaimer, the original version will prevail.

If a section in the Document is Entitled "Acknowledgements", "Dedications", or "History", the requirement (section 4) to Preserve its Title (section 1) will typically require changing the actual title.

9. TERMINATION

You may not copy, modify, sublicense, or distribute the Document except as expressly provided for under this License. Any other attempt to copy, modify, sublicense or distribute the Document is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

10. FUTURE REVISIONS OF THIS LICENSE

The Free Software Foundation may publish new, revised versions of the GNU Free Documentation License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns. See http://www.gnu.org/copyleft/.

Each version of the License is given a distinguishing version number. If the Document specifies that a particular numbered version of this License "or any later version" applies to it, you have the option of following the terms and conditions either of that specified version or of any later version that has been published (not as a draft) by the Free Software Foundation. If the Document does not specify a version number of this License, you may choose any version ever published (not as a draft) by the Free Software Foundation.

How to use this License for your documents

To use this License in a document you have written, include a copy of the License in the document and put the following copyright and license notices just after the title page:

Copyright (c)  YEAR  YOUR NAME.
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2
or any later version published by the Free Software Foundation;
with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
Texts.  A copy of the license is included in the section entitled "GNU
Free Documentation License".

If you have Invariant Sections, Front-Cover Texts and Back-Cover Texts, replace the "with...Texts." line with this:

with the Invariant Sections being LIST THEIR TITLES, with the
Front-Cover Texts being LIST, and with the Back-Cover Texts being LIST.

If you have Invariant Sections without Cover Texts, or some other combination of the three, merge those two alternatives to suit the situation.

If your document contains nontrivial examples of program code, we recommend releasing these examples in parallel under your choice of free software license, such as the GNU General Public License, to permit their use in free software.